Bug 169820 - VWP / Woodstock to JSF 2.0 Migration (e.g. via Wizard)
VWP / Woodstock to JSF 2.0 Migration (e.g. via Wizard)
Status: NEW
Product: javaee
Classification: Unclassified
Component: Web Project
All All
: P1 with 79 votes (vote)
Assigned To: David Konecny
Depends on:
  Show dependency treegraph
Reported: 2009-08-04 14:22 UTC by jokers
Modified: 2012-02-28 19:29 UTC (History)
3 users (show)

See Also:


Note You need to log in before you can comment on or make changes to this bug.
Description jokers 2009-08-04 14:22:53 UTC
Dear all,

VWP / Woodstock in maintenance mode. ICE-Faces has stopped their vwp project too.

Please provide us with a migration path from VWP / Woodstock to your JSF 2.0 Module.

In my point of view a migration wizard, would be the best way to go. 
(priority 1, since this might regain some lost trust into the ide).
Comment 1 averri 2009-08-11 13:35:22 UTC
I think that it is a very important issue!
Comment 2 Petr Jiricka 2009-08-13 09:02:51 UTC
When speaking of migration of VWP/Woodstock to something else, there are many different approaches possible. These range
from making the minimal changes possible, so that the application can be maintained going forward without VWP/Woodstock
and is able to run with the latest browser, all the way to modernizing it to use the latest technologies and following
up to date JSF development practices. The difference will be in the effort required - while the minimal approach could
be relatively easy to do mechanically, the full-blown approach will require a significant investment into existing apps,
and most likely can not be automated. The various migration steps to consider are:

1/ Replacing the Woodstock library with ICEFaces or another library (RichFaces, Trinidad/Tobago etc.)
2/ Converting jspx syntax to facelets
3/ Replacing data access through RowSets with Java Persistence
4/ Using JSF 2.0 instead of 1.2 and taking advantage of the important 2.0 features
5/ Overall improvements of the application architecture (e.g. get rid of the backing beans concept)

I would like to ask everyone interested in this topic, which of the above are you interested in? Is it more important
for you to use the latest specs and practices, or to spend only minimal effort on the migration? Thanks for your insights.

Comment 3 jokers 2009-08-13 14:58:48 UTC
Starting with a "minimal effort on the migration" sounds good. 
After such a migration we will see, what has to be done to fulfil the latest specs and if it's worth the effort in
context of the individual application.

I fully agree with your suggested steps (1-5) in this order, if there is no way to revitalise some kind of VWP or
Woodstock for the JSF 2.0.Module – what is a fact as far as I can see. 

In summary one can say: help is needed to come as close to the new direction as possible, with reasonable resources.
Comment 4 alesak 2009-09-01 22:08:41 UTC
For me is the most important first step, but with full visual editor support and with "ALL" !!! Woodstock like
components available in a replacement library. I don't actually need full wizard, but fully working replacement library
will be enough for me.
Comment 5 msdobrescu 2009-09-02 06:48:35 UTC
I would like ICE-Faces and current 6.5 VWP functionality.
Comment 6 xcallejas 2009-09-02 06:58:18 UTC
Woodstock components are great! the woodstock table is very very useful and complete, and they are AJAX enable (and
works even better in combination with DynamicFaces)... so why don't someone re-take the project instead of let it die
completely? why we need to change to an other component library instead of keep using and improving project woodstock? I
think I would pay a razonable price for a kind of support.

Comment 7 fedevela 2009-09-02 13:12:18 UTC
Hi all!

I would like to second xaviers motion and say that I personally am truly fond of woodstock and contribute a little of my
user-side experience with woodstock as the architect of electronic payments software using woodstock.

At a certain point I decided to stay in version 4.1 (a good decision in hindsight, although I sacrificed a lot of AJAX
for now) and the components are truly great, responsive, stable, easily customizable, and have browser compatibility.

I have given great thought to the two available options: migrating to ICEFaces or rolling my sleeves up and contribute
to keep the woodstock community (commercial support would be the cherry on top).

Xavier's post makes me want to reconsider option 2.



PS: visual web pack + woodstock + jsf templating would make an amazing power builder type framework.
Comment 8 jamesarbrown 2009-09-02 15:07:05 UTC
Humm... I have been around the block a bit now trying to find an alternative and I am back here!

6.5 with VWP & Ice faces was the simplest, but then came 6.7 and VWP on stop

So I looked at Eclipse.... no automatic bindings and so on... looked hard to get started and difficult to start learning
persistance and how to programme when you are used to dropping a database table onto your project.

So I looked at Jdeveloper 11g.... highly highly impressed at the GUI, highly impressed at the quality and quantity of
ADF components. Not too sure on layout in the editor, but never got that far in. But then I came to deployment and
licencing. Deployment would simply just not happen on Tomcat for an ADF project, tried with bundled Weblogic app server
out of the box and that did not work. More clarity on licencing and open community from Oracle and this would rock.

So my last alternative is Myeclipse and probably Myfaces......not hopeful.. which got me thinking.

Netbeans VWP was bar far the best, simplest way to throw a web app together and I can not comprehend on little bit why
it has all been shelved. 

With the Oracle Sun thing going on somewhere some rationalisation must come in between Glassfish/WLS and NB/Jdev which
is a further concern.

Pity NB can not have a new VWP editor with something say like Myfaces (Which I think is based on ADF from Oracle) or
even IceFaces. At least using Myfaces would save upgrading woodstock and just leave VWP to be upgraded.

Looked at the current Web tutorials on NB6.7.... what a disgrace of complication.

Comment 9 xcallejas 2009-09-03 15:11:59 UTC
I forgot to mention that the combination of Woodstock + JPA is very powerful.
Comment 10 riftware 2009-09-03 15:27:38 UTC
We use Ice Faces and have for some time so my preferences is that updates be capable of laying out ice faces components.   

Frankly the visual editor portions of netbeans were one of the few reasons anybody in my company even looks at netbeans
anymore.   They prefer eclipse because it works more intuitively for them from a debugging point of view and they don't
have the issues with code completion/scanning and also they've never had to delete a cache file to get eclipse to
properly figure out code completion/status symbols like we have to do periodically with netbeans.  At one point I hade
70% of our developers trying Netbeans for about 3 months based on the leverage of OpenESB required netbeans.   They got
so fed up with Netbeans they threw out OpenESB in favor of ServiceMix.   The one area Netbeans has always had a lock on
though, where it was a first class IDE was first in visual editing / layout of swing apps, and then in visual editing
and layout of web apps.   To me, not following and maintaining that capability is like throwing away one of the best
things about netbeans simply because it will take work to stay first class.
Comment 11 d1g1mon 2009-09-04 17:56:35 UTC
Visual JSF (Woodstock/ICEFaces) was one the main drivers for our choosing Netbeans; as well as, support excellent
support on Solaris (SPARC/X86) vs. Eclipse. The application/session/page beans provided in Visual JSF projects are also
a great time saver.
Comment 12 bardu 2009-09-04 19:00:03 UTC
I have used the Studio Creator since RC1 and later on NB/VWP/Woodstock. It is a shame to ditch VWP/Woodstock. I also
wouldn't mind to pay a reasonable fee for support.
Comment 13 fkjaekel 2009-09-08 12:22:56 UTC
Here in Brazil Java is losing a lot of space to .NET because of the lack of a good out of the box tool.

NetBeans Visual Web Pack is great, it must be improved and continued.
Comment 14 lfabbri 2009-09-10 16:32:59 UTC
I started with Studio Creator, then migrating to NetBeans + Woodstock and now IceFaces, solely because of the visual web
designer. So for me No VWP = Goodbye, NetBeans!

What I would like to see is VWP capabilities based on JSF 2.0, but with some sort of wizard to migrate apps based on JSPs.
Comment 15 vmplosila 2009-09-10 20:15:53 UTC
I think VWP is very important part in NetBeans for many users.

We are now using in our projects NetBeans VWP with old (J2EE Sun JSF components), migrated from Studio Creator about two
years ago. 

Now we are planning to convert our projects to Java EE 5 platform with Visual JSF’s Woodstock components, because the
migration is the easiest with these components.

I think the most important thing for corporate users is to keep/maintain Visual  JSF  functionality in NetBeans  and
keep it up to date. For visual UI component sets I think the Woodstock components are the most easiest to use because
VWP does many things automatically for developer.  

There should be some kind of migration wizard to Java EE 6 and JSF 2.0 platform with good Visual JSF component set
(Icefaces, ?, ?) but older Java EE 5 should be maintained in future releases of NetBeans as it is now with J2EE 1.4

This kind of visual web functionality (VWP) is default in .Net environment so I think NetBeans should also have it and
keep it up to date for Java developers!
Comment 16 marcosalexandre 2009-09-10 21:02:22 UTC
IceFaces Visual Plugin is better, but environment visual was broken in version 6.7. 
Woodstock is dead
Comment 17 jerichammond 2009-09-10 22:14:08 UTC
I have NB 6.7 on my Mac, and Woodstock compatibility seems to be completely fixed. For now, that is great (for my work). But I agree, the visual interface is 
important, and needs to work with the new deal, IceFaces in this case.
I have done my time fighting with Visual C++, and I CAN hand code the GUI, but the visual editor allows me to focus on the real work. Without the visual 
editor, I would be using Eclipse, it has some great features that NetBeans either had and broke, or maybe never had.
Comment 18 jamesarbrown 2009-09-11 12:41:18 UTC
Hi All,

I think a grasp of reality is needed. NB just needs a new VWP editor to start with.... as for migration wizard well
thats and onward step and realistically such a structure change is going to mean a recode, not a wizard.... are JSP's
not vanishing?

So please request for a VWP first, then we might have something to migrate too.

As for the component library, Ice tends to break with panels in panels etc, works, but VWP does not display properly. I
have to say I had an easier coding and VWP with woodstock.


Comment 19 vmplosila 2009-09-11 13:43:22 UTC
Although Woodstock project is dead it is still the most easiest and usable component set to use with VWP. You don’t have
spent time routing things with Woodstock. It is just sad this project died.

I think JB is right. What NetBeans needs right now is to get new Visual JSF editor (what support old projects too).
Conversion wizards etc. stuff later…
Comment 20 lfabbri 2009-09-11 13:53:03 UTC
I second the prioritization of any VWP over the migration wizard.

However having happily used Woodstock from its birth to its death and then begrudgingly switched to IceFaces, now the
superiority of the latter over the former is in my mind undisputable.
Comment 21 vmplosila 2009-09-13 15:29:38 UTC
After lucafs comments I have done some serious tests with IceFaces Visual JSF  in NetBeans 6.5.1 and I must say it is
really working. Some things are harder to do (much more coding) than with Woodstock but many things are better with
IceFaces. Very important thing is that IceFaces is under active development and it is not dead (you get support etc.) .
The Visual JSF with IceFaces is really working in 6.5.1.  I think we must go back to 6.5.1 and do migration to IceFaces
Visual JSF.

So, the best thing what would happen in Visual JSF future is that NetBeans staff and IceSoft cooperate and make Visual
JSF with IceFaces stabile part of future NetBeans releases.  

My answer to pjirickas question is: 

1. Replacing the Woodstock library with IceFaces

Comment 22 jokers 2009-09-15 08:09:58 UTC
One advantage of a migration is JSF 2.0.  It contains facelets functionality, that is enormous time-saver for
development and maintenance of a project. 

An other advantage is staying state of the art and 
protecting the invests of new and old projects.
Comment 23 fedevela 2009-09-15 12:53:42 UTC
IMO JSFTemplating would be the way to go for facelets (and other syntaxes) support. Regards.
Comment 24 marioprado 2009-09-29 18:06:13 UTC
In my opinion one migration wizard is not enought. We should really work for the continuation of support for the visual
Comment 25 jokers 2009-10-01 12:10:08 UTC
Dear netbeans team, 
since this is a top voted issue, please give us a feedback now!
What is the status, internal discussion and roadmap on this problem?
Comment 26 vmplosila 2009-10-01 19:27:39 UTC
I am very interested about this issue situation too. Roadmap or something is needed.
Comment 27 mariano_lopez 2009-10-02 07:54:27 UTC
I think too that VWP is one of the most important parts of NetBeans.

It's the unique decent visual design for web pages with a very good components. All my applications works very well with
this framework.

I never have been looking for alternatives until VWP pass to manteinance mode. I hope that this situation will be
reversible in the future.

Now I am working with NetBeans 6.7.1 and VWP and there is some basic problems like data bindings in forms. I put several
issues for fixing them. Take a look at:

Comment 28 magsam 2009-10-02 14:38:41 UTC
In may 2007 netbeans made a high progress with developing web application. Vwp with Woodstock was great for us. We liked
to develop with it. We the community know exactly what we need for our work.  The guys from netbeans could be proud for
this. But one day a manager from sun decided to kill Woodstock and vwp. This man is a theorist. He is fare fare away
from practise. He took away what we urgently need. There was no real reason for this decision. Each day we see such
strange and totally wrong decisions. We see in reaction of the community that a lot of people want and need vwp. Sun
gave us no real alternative. I tried to convert from Woodstock to ice faces. This is not possible. A redesign is faster
than a conversion. 

Lets hope and pray that this absurdly decision will cancelled. Netbeans with vwp is the best IDE !!

Since 6.5 woodstock components are very slow I say extreme slow. It seems sun wants us to go away from Woodstock. !!!
Comment 29 vmplosila 2009-10-03 13:21:02 UTC
We have now migrated one of our applications from old Studio Creator 2.1 based project to IceFaces Java EE 5 Visual JSF
application. First plan was migration to Woodstock components but that was forgotten because of the project Woodstock
inactive state. Decision was that the best development environment for us is go back NetBeans 6.5.1+Visual JSF framework
+ IceFaces components. Conversion work was quite big but I think it was good choice because there is future guaranteed
with IceFaces.

I think more important issue than continue active Woodstock development (which is very good component set too) is that
NetBeans staff include the VWP framework in NetBeans active modules in future,  so other component vendors (ex. IceSoft)
are willing to do VWP plugins.  Now they won’t do because of VWP maintain mode. This would be the ideal situation when
everyone could use their choice of JSF components in NetBeans VWP framework. 

Comment 30 krahe 2010-01-11 10:41:24 UTC
Most of my applications are Swing-based, but I did have a need for a web component, for which I used NetBeans' Visual Web.  Being new to JSF, I chose what I thought was at least a current and modern framework.  When the VW plug-in had to be optionally enabled in NB 6.7, I thought the developers were just trying to shrink the space and size required for a basic install of NB.  I was rather shocked when it disappeared altogether in 6.8.

NB 6.8 solves a host of problems apparently related to external root registration, which affects most of my projects, so it's really not an option to stick with an earlier version.  However, I must still keep 6.7 around in case I need to work on my one web component.

My first desire would be some kind of migration path from 6.7 to 6.8 that would at least allow me to build my VW project, even if I could only edit the source code manually without a visual web editor.  Ultimately I would think there's significant demand from the development community for a visual web development tool, to be used with NetBeans or another framework, to which I would hope I can migrate.
Comment 31 omoz4real 2010-06-10 16:29:40 UTC
I think netbeans Visual Web JSF with woodstock was one of the best features of netbeans and when it disappeared, it was kind of shocking. My suggestion would be to find a way to integrate woodstock components with VWP and JSF 2.0 so that visual web projects could use facelets instead of JSP and also maybe provide a forum where users of woodstock/VWP could contribute financially and voluntarily so that the team of developers working on the components can go around doing their business of providing us with these great web components.
Comment 32 dandotgov 2010-07-09 13:18:25 UTC
I have large projects developed using Netbeans 6.5.1, JSF and Woodstock. As these are no longer supported in the current versions, and there is no conversion wizard available, I cannot use later versions of Netbeans, JDK, etc..

There is no way I can justify the expense of a manual conversion to JSF 2.0/Facelets.
Comment 33 javydreamercsw 2010-07-16 13:44:50 UTC
I think a feasable option is merging JDeveloper into Netbeans. JDeveloper lacks the RCP approach but has features missing in Netbeans. Also as a side effect this would get the resources that Netbeans is lacking right now.

This would bring stuff into Netbeans like:

1. Integration with Oracle database
2. Visual design (Oracle ADF)
Comment 34 jamesarbrown 2010-07-16 14:26:58 UTC
I am sorry to say this, but I think its NB that has the limited life (unless forked if possible under the CDDL), not JDeveloper.

From articles I have seen the Oracle people whom are making the future path decisions hold JDev in much higher regard than NB for VWP and more importantly Jdev ties with Oracle sellable products.

Lets all remember Sun = Open Source, Oracle = fastest route to your wallet, things will change, but I just can not see NB having a VWP editor replacement when Jdev exists and is infact not that bad.

Must say though their ADF to SQL databinding is absolutely atrocious. Drag and drop in NB. ;)

Comment 35 nbc 2010-07-23 11:52:32 UTC
I've been using Netbeans since long before Sun picked up the project, but a visual development environment is very important to me. I have not upgraded past NB6.5 and I may have to start looking for alternatives. I'd rather not do that if I don't have to...

Comment 36 jokers 2010-07-29 11:47:38 UTC
Thank you for starting to think about it:

Comment 37 GeraldoLuiz 2010-08-14 11:38:50 UTC
Yes, count me in. It' a very needed feature that should have never been withdrawn from NB. I think a JSF 2/Facelets version of VWP with IceFaces (RichFaces or any other faces) is preferable to a migration wizard as a fist priority right now. NB was once the best IDE because of this but not anymore. Really bad decision indeed to remove this most wanted and cherished feature from NB!
Comment 38 David Konecny 2010-09-07 22:55:23 UTC
My name is David Konecny and I'm technical lead for EE support in NetBeans. Since the beginning of this year I've been on and off thinking about JSF Visual Editor. My thoughts resulted into a BOF session at coming JavaOne: "Give Me a Proper Visual JavaServer Faces Editor or Else ..." (http://javaonedevelop.com/e/1862). It's more of an analysis of the current state than promise of a new tool. In any case I would love to talk to anybody with interest in the subject so if you are visiting J1 stop by the BOF, the NetBeans stand or do not hesitate to contact me directly.

PS: to avoid confusion (and disappointment) I should say that this is my personal interest and nothing else. There is no NetBeans project scheduled to address issues identified in this bug or my BOF as of this time.
Comment 39 israfil 2010-10-11 15:36:06 UTC
Dropping Visual Web Pack & Woodstock from NetBeans was simply a sabotage against theopen source project who produced one of the stronger Visual Studio competitors in software development. Please read http://www.theregister.co.uk/2010/01/29/oracle_sun_java_open_source/
Comment 40 lfabbri 2010-10-11 17:56:55 UTC
I am uncomfortable with the prospects for NetBeans and am moving to Eclipse. If you are looking for a visual web development tool you should check out GWT and the GWT Designer visual web development tool Google just acquired. It looks pretty good, especially if you add to it an additional widget library like Ext-GWT.
Comment 41 sujithb 2011-08-02 08:46:05 UTC
Woodstock components are great! the woodstock table is very very useful and
complete, and they are AJAX enable (and
works even better in combination with DynamicFaces)... so why don't someone
re-take the project instead of let it die
completely? why we need to change to an other component library instead of keep
using and improving project woodstock? I
think I would pay a razonable price for a kind of support.
Comment 42 jokers 2011-11-16 08:03:37 UTC
Hello David Konecny,

can you please give all interested listeners to this thread an update on this issue.
Comment 43 krahe 2011-11-16 15:22:21 UTC
Since I had made some earlier comments and progressed into further web development sans Woodstock since then, I thought it only fair to post an update.

I have begun developing a new web application using the PrimeFaces components ( http://www.primefaces.org/ ) as well as JSF 2.0 under NetBeans 7.0.1 and deploying to Glassfish 3.1.1.  While there is no visual WYSIAWYG tool for NB7/PrimeFaces, I must say that the code I'm ending up with is ultimately simpler and easier to follow than what I got when I was developing with Woodstock/JSF 1.2.  And I'm finding out that letting JSF/Facelets/CSS handle much of the organization, layout and appearance of my pages isn't such a bad idea.  I haven't converted my old (thankfully simple) Woodstock application to JSF 2.0/PrimeFaces yet, but I plan to do so eventually, and don't expect it to be a big deal.

I do have a couple book recommendations for anyone who endeavors to make the break from Woodstock like I did.  One is "HTML, XHTML, & CSS All-In-One for Dummies" by Andy Harris.  The other is "Core JavaServer Faces, Third Edition," by David Geary and Cay Horstman.  One caveat with the first book is that while it promotes using CSS to handle page layout rather than the "old" way of using HTML tables, JSF/Facelets continues to depend on tables, but itself addresses some of the issues that led the author to prefer CSS, so read that section with a grain of salt.  And if you have the Second Edition of the other book (Core JavaServer Faces), throw it out - it's obsolete!
Comment 44 David Konecny 2011-11-16 19:21:00 UTC
(In reply to comment #42)
> Hello David Konecny,
> can you please give all interested listeners to this thread an update on this
> issue.

Unfortunately I have nothing new to say.
Comment 45 mountainer 2012-02-28 18:00:31 UTC
Have been working with vwp since Java Studio Creator, and then migrated to NP 5.5->6.1->6.5->6.7, now the VWP is dropped, I'll stop upgrade to the new version until getting VWP back.
Comment 46 fkjaekel 2012-02-28 19:03:44 UTC

Consider migrating your projects to PrimeFaces.
Comment 47 javydreamercsw 2012-02-28 19:29:09 UTC
Migrate to a different technology. VWP won't get back. Don't bet on it or you'll be waiting forever.

By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo